
<template>
    <el-container style="height: 100%">
        <el-header>
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                <div >
                  <el-row class="servicerow" type="flex" justify="center" >
                    <el-col :lg="12" :md="15" :sm="18" :xs="24" class="servicecol">
                      <el-card class="el-card" v-if="shopInfo !== null">
                        <el-row :gutter="60" class="servicerow" type="flex" >
                          <el-col :lg="10" :xs="24" class="servicecol">
                            <img :src="shopInfo.shopImage" class="image">
                          </el-col>
                          <el-col :lg="14" :xs="24" class="servicecol">
                            <span style="text-align: center;display:block; font-size: 1.6em;">{{shopInfo.shopName}}<br></span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店介绍：'+shopInfo.shopIntroduction}}</span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店类型：'+shopInfo.shopType}}</span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店地址：'+shopInfo.shopLocation}}</span>
                          </el-col>
                        </el-row>
                      </el-card>
                    </el-col>
                  </el-row>

                  <el-row  :gutter="20"  class="servicerow" type="flex">
                    <el-col :lg="6" :xs="24"  v-for="(item,index) in servicesList" id=item :key="item.serviceID" class="servicecol">
                      <el-card class="el-card"  :key="index"  onclick="" v-if="(index >=(page.currentPage-1)*page.pageSize) && (index <(page.currentPage)*page.pageSize)">
                        <img :src="item.serviceImage" class="image">
                        <div style="padding: 14px;">
                          <span style="text-align: center;display:block; font-size: 1.5em;">{{item.serviceName}}<br></span>
                          <span style="display:block; font-size: 0.8em; width:auto;" v-if="item.serviceCategory">{{'锻炼类型：'+item.serviceCategory}}</span>
                          <span style="display:block; font-size: 0.8em; width:auto; ">{{'锻炼热量：'+item.serviceCalorie+'cal'}}</span>
                          <span style="display:block; font-size: 0.8em; width:auto; ">{{'运动场地：'+item.serviceLocation}}</span>
                          <span style="display:block; font-size: 0.8em; width:auto; ">{{'运动简介：'+item.serviceIntroduction}}</span>
                          <span style="display:block; width: auto; font-size: 0.8em;">{{'运动时长：'+item.serviceTime}}</span>
                          <div style="width: 100%; text-align:center;"  v-if="islogin">
                            <span style="width: auto; font-size: 0.7em;">预约时长(MIN)</span>
                            <el-input-number size="mini" v-model="nums[item.serviceId]" :min="0" :max="7200" :step="10"></el-input-number>
                          </div>
                        </div>
                      </el-card>
                    </el-col>
                  </el-row>
                  <span></span>
                </div>
                <div style="width: 100%; text-align:center; position:sticky; bottom:0;"  v-if="islogin">
                  <el-button type="success" round @click="postGymOrder()" :disabled="disable">预约</el-button>
                  <el-button type="danger" round @click="reset()">重置</el-button>
                </div>
                <div id="pager" class="pager01">
                  <el-pagination
                  @current-change="CurrentChange"
                  background layout="total,  prev, pager, next, jumper"
                  :total="servicesList.length"
                  :page-size="8"
                  :current-page.sync="page.currentPage"
                  >
                  </el-pagination>
                </div>
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import BrowseServiceByShopID from '@/services/BrowseServiceByShopID'
import showViewInfoService from '@/services/showViewInfoService'
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'BrowseServiceByShopID',
  data () {
    return {
      page: {
        pageSize: 8,
        currentPage: 1,
        total: 0
      },
      shopInfo: null,
      servicesList: [],
      user: {
      },
      islogin: 0,
      disable: false,
      checkList: [],
      nums: {}
    }
  },
  created () {
    this.islogin = this.$store.state.token !== ''
    this.getShopServicesList()
    this.getUserInfo()
  },
  methods: {
    // 获取商品列表
    async getShopServicesList () {
      try {
        console.log(this.$route.params.id)
        const response = await BrowseServiceByShopID.getShopServiceList(this.$route.params.id, {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log(response.data)
        this.servicesList = response.data.data.shopServices.serviceList
        this.shopInfo = response.data.data.shopServices
        console.log('成功')
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
        this.$router.go(-1)
      }
    },
    async getUserInfo () {
      if (!this.islogin) {
        return
      }
      try {
        const response = await showViewInfoService.getInfo({
          headers: {'Authorization': this.$store.state.token}
        })
        this.userInfo = response.data.data.user
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
        this.$router.go(-1)
      }
    },
    Goservice (serviceId) {
      console.log('in')
      console.log(this.$route.path)
      this.$router.push(this.$route.path + '/' + serviceId)
    },
    pages () {
      console.log('pages')
      const pages = []
      this.servicesList.forEach((item, index) => {
        const page = Math.floor(index / 2)
        if (!pages[page]) {
          pages[page] = []
        }
        pages[page].push(item)
      })
      console.log('pages')
      return pages
    },
    handleCurrentChange (val) {
      var thispage = this
      thispage.currentpage = val
      thispage.initPage()
    },
    CurrentChange (currentPage) {
      this.page.currentPage = currentPage
    },
    async postGymOrder () {
      if (!this.islogin) {
        this.$message({
          type: 'error',
          message: '尚未登陆无法结算'
        })
        return
      }
      var Gyms = []
      var totalService = 0
      for (var i in this.nums) {
        var dict = {}
        if (this.nums[i] !== undefined && this.nums[i] !== 0) {
          dict['serviceId'] = i
          dict['serviceAppointmentTime'] = this.nums[i]
          Gyms.push(dict)
          totalService += this.nums[i]
        }
      }
      this.disable = true
      console.log(Gyms)
      try {
        const response = await BrowseServiceByShopID.Order({
          serviceOrderUserId: this.userInfo.userId,
          serviceOrderShopId: this.$route.params.id,
          serviceOrderArrivalTime: Date.now(),
          serviceList: Gyms,
          serviceOrderTotalTime: totalService
        }, {
          headers: {'Authorization': this.$store.state.token}
        })
        if (response.data.code !== 200) {
          this.$message({
            type: 'error',
            message: response.data.msg
          })
        }
        this.$message({
          type: 'success',
          message: response.data.msg
        })
        for (var r in this.nums) {
          this.nums[r] = 0
        }
        this.$forceUpdate()
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
      }
      this.disable = false
    },
    reset () {
      for (var i in this.nums) {
        this.nums[i] = 0
      }
      this.$forceUpdate()
    }
  }
}

</script>

<style scoped>
  .time {
  font-size: 13px;
  color: #999;
  }
  .bottom {
  margin-top: 13px;
  line-height: 12px;
  }
  .button {
  padding: 0;
  float: right;
  }
  .image {
  width: 100%;
  display: block;
  }
  .clearfix:before,
  .clearfix:after {
      display: table;
      content: "";
  }
  .clearfix:after {
      clear: both
  }
  .servicerow {
  margin-bottom: 20px;
  display: flex;
  flex-wrap: wrap
  }
  .servicerow .servicecol {
  border-radius: 4px;
  align-items: stretch;
  margin-bottom: 0px;
  margin-top: 20px;
  }
  .el-card{
    height: 100%;
    min-width: 100%;
    transition: all .5s;
  }
  .el-header {
  background-color: #333;
  }
  .el-main {
    padding-top: 0;
  }
  .pager01{
    left:0;
    bottom: 0;
    width:100%;
    height:50px;
    text-align: center;
    list-style: none;
    padding-top:8px;
  }
</style>
